--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    16:49:34 09/13/07
-- Design Name:    
-- Module Name:    seccount - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---------------------------------------------------------------
entity seccount is
  port(clk            : in  std_logic;

--       rx             : in std_logic;
--		 tx             : out std_logic;

       button         : in  std_logic_vector(3 downto 0);  -- reset
		 switch         : in  std_logic_vector(7 downto 0);
	    led            : out std_logic_vector(7 downto 0);

	    digit_segment  : out std_logic_vector(8 downto 0);
	    digit_anode    : out std_logic_vector(3 downto 0)

--       vga_red        : out std_logic;
--       vga_green      : out std_logic;
--       vga_blue       : out std_logic;
--       vga_hsync      : out std_logic;
--       vga_vsync      : out std_logic;

--       ram_addr       : out std_logic_vector(17 downto 0);
--       ram_we         : out std_logic;
--       ram_oe         : out std_logic;
--       ram_a_data     : inout std_logic_vector(15 downto 0);
--       ram_a_ce       : out std_logic;
--       ram_a_lb       : out std_logic;
--       ram_a_ub       : out std_logic;
--       ram_b_data     : inout std_logic_vector(15 downto 0);
--       ram_b_ce       : out std_logic;
--       ram_b_lb       : out std_logic;
--       ram_b_ub       : out std_logic;

--       din            : in std_logic;
--		 reset_prom     : out std_logic;
--		 cclk           : out std_logic

	   );  
end seccount;

---------------------------------------------------------------
architecture Behavioral of seccount is

--------------------------------------------
component Ctrl4x7Seg is
  port (clk_in      : in  std_logic;
        reset_in    : in  std_logic;
		  bcd0_in     : in  std_logic_vector(3 downto 0);
		  bcd1_in     : in  std_logic_vector(3 downto 0);
		  bcd2_in     : in  std_logic_vector(3 downto 0);
		  bcd3_in     : in  std_logic_vector(3 downto 0);
		  char_out    : out std_logic_vector(7 downto 0);
		  chsel_out   : out std_logic_vector(3 downto 0) 
		  );
end component;

--------------------------------------------
component BcdCount is
  port (clk_in      : in std_logic;
        enable_in   : in std_logic;
        reset_in    : in std_logic;
        carry_in    : in std_logic;
        bcd_out     : out std_logic_vector(3 downto 0);
        carry_out   : out std_logic
        );
end component;

--------------------------------------------
component MovLight is
	generic(ledwidth			: integer range 2 to 32 := 2;
			clkdiv				: integer range 1 to 50000000 := 1
			);
	port(	clk_in      		: in  std_logic;
			reset_in    		: in  std_logic;
			ledvector_out   	: out  std_logic_vector(ledwidth-1 downto 0)
		);
end component;


--------------------------------------------
  signal clk_1hz : std_logic;
  signal reset   : std_logic;

  signal bcd0    : std_logic_vector(3 downto 0);
  signal bcd1    : std_logic_vector(3 downto 0);
  signal bcd2    : std_logic_vector(3 downto 0);
  signal bcd3    : std_logic_vector(3 downto 0);

  signal carry0  : std_logic;
  signal carry1  : std_logic;
  signal carry2  : std_logic;
  signal carry3  : std_logic;

  signal digit_num : std_logic_vector(7 downto 0);


--------------------------------------------
begin
  reset <= button(0);

  process (clk, reset)
  variable   count_clk   : integer range 0 to 50000001 := 0;
  begin
    if reset = '1' then
      count_clk := 0;
	  clk_1hz <= '0';
    elsif rising_edge(clk) then
	  if count_clk = 0 then
		count_clk := 50000000;
		clk_1hz <= '1';
	  else
        count_clk := count_clk - 1;
		clk_1hz <= '0';
	  end if;
    end if;
  end process;

  --led(0) <= clk_1hz;

  I11: BcdCount port map (clk, clk_1hz, reset,    '1', bcd0, carry1);
  I12: BcdCount port map (clk, clk_1hz, reset, carry1, bcd1, carry2);
  I13: BcdCount port map (clk, clk_1hz, reset, carry2, bcd2, carry3);
  I14: BcdCount port map (clk, clk_1hz, reset, carry3, bcd3, carry0);
  I15: Ctrl4x7Seg port map (clk, reset, bcd0, bcd1, bcd2, bcd3, digit_num, digit_anode);

  digit_segment <= '1' & digit_num;

  I21: MovLight generic map (ledwidth => 8, clkdiv => 5000000) port map(clk, reset, led);

end Behavioral;
---------------------------------------------------------------
